{{GpsTest3aNoDebug.spin 2-4-09 1625 }}
                
CON

  _CLKMODE = XTAL1 + PLL8X  'set's clock cycle parameters
  _XINFREQ = 10_000_000

var

  long Sats, Lat, Longitude, valid, CurrentDegreesGps, LongHigh, LongLow, LatHigh, LatLow, DestLat, DestLong
  long Stack[15], CurrentDestGpsHigh, CurrentDestGpsLow

obj

  gps : "GPS_SmartMode"
  debug : "Debug_LCD"
  move : "Servo_Objects_15"
  Compass : "Sensor.HM55B.Compass"
  ping : "Pinger"
                         
pub Main
  pause(5000)
  compass.start(3,4,5)
  gps.Start(GPS#EASTERN_TIME, TRUE)
  valid := gps.GetValid
  sats := gps.GetSats
  Lat := gps.GetLatitude
  Longitude := gps.GetLongitude
  valid := gps.GetValid
  CurrentDegreesGps := Compass.Degrees
'  Debug.init(15, 19200, 2)
'  Debug.cls
{  
repeat until valid == 1
  debug.str(string("WHY!!!" ))
  pause(500)
  debug.cls
  valid := gps.GetValid
actualwork  
}
'pub actualwork
'    debug.cls
    DestLong := -805987 '281859    
    longitude := gps.GetLongitude
    CurrentDegreesGps := Compass.Degrees    
    if DestLong > Longitude
      Longitude := Gps.GetLongitude
'      LongHigh := Longitude + 1
'      LongLow := Longitude - 1
      repeat until DestLong == Longitude '=< LongHigh and DestLong => LongLow
        longitude := gps.GetLongitude
'        debug.dec(DestLong)
'        Debug.str(string(","))
'        debug.dec(Longitude)
'        Debug.Str(string(","))
'        Debug.dec(LongHigh)
'        debug.str(string(","))
'        Debug.Dec(LongLow)
'        pause(5000)
        debug.cls
        CurrentDegreesGps := Compass.Degrees
          if CurrentDegreesGps < 270 and CurrentDegreesGps > 90
            repeat until CurrentDegreesGps => 88 and CurrentDegreesGps =< 92
              Move.TankLeft(1)
              CurrentDegreesGps := Compass.Degrees
'              Longitude := Gps.GetLongitude
'              Debug.Dec(Longitude)
'              debug.str(string("DO>LOL,"))
'              debug.dec(CurrentDegreesGps)
'              pause(5000)
'              debug.cls
          if CurrentDegreesGps < 90
            repeat until CurrentDegreesGps => 88 and CurrentDegreesGps =< 92
              Move.TankRight(1)
              CurrentDegreesGps := Compass.Degrees
'              Longitude := Gps.GetLongitude
'              Debug.Dec(Longitude)
'              Debug.Str(string("DO>LOR,"))
'              Debug.Dec(CurrentDegreesGps)
'              Pause(5000)
'              Debug.cls
           
        Longitude := Gps.GetLongitude
        move.AllForward(20)
        Longitude := Gps.GetLongitude
     
    if DestLong < Longitude
      Longitude := Gps.GetLongitude
'      LongHigh := Longitude + 1
'      LongLow := Longitude - 1 
      repeat until DestLong == Longitude '=< LongHigh and DestLong => LongLow
        Longitude := Gps.GetLongitude
'        Debug.Dec(DestLong)
'        Debug.str(string(","))
'        debug.dec(longitude)
'        Debug.Str(string(","))
'        Debug.dec(LongHigh)
'        Debug.str(string(","))
'        Debug.Dec(LongLow)
'        pause(5000)
'        debug.cls
        CurrentDegreesGps := Compass.Degrees
        if CurrentDegreesGps > 90 and CurrentDegreesGps < 270
          repeat until CurrentDegreesGps => 268 and CurrentDegreesGps =< 272
            Move.TankRight(1)
            CurrentDegreesGps := Compass.Degrees
   '         debug.dec(Longitude)
  '          Debug.Str(string("DO<LOR,"))
 '           Debug.Dec(CurrentDegreesGps)
 '           pause(5000)
 '           Debug.cls
        if CurrentDegreesGps < 90
          repeat until CurrentDegreesGps => 268 and CurrentDegreesGps =< 272
            Move.TankLeft(1)
            CurrentDegreesGps := Compass.Degrees
'            Longitude := Gps.GetLongitude
 '           debug.Dec(Longitude)
'            Debug.str(string("DO<LOL,"))
'            Debug.Dec(CurrentDegreesGps)
'            Pause(5000)
'            Debug.cls
        if Ping.PingF
          ObstacleAvoid
        Move.AllForward(20)
        if Ping.PingF
          ObstacleAvoid     
        Longitude := Gps.GetLongitude
     
     
    DestLat := 281857 '-805985     
    if DestLat > Lat                 'less is west
      lat := gps.GetLatitude
'    LatHigh := Lat + 1
'    LatLow := Lat - 1
      repeat until DestLat == Lat '=< LatHigh and DestLat => LatLow
        Lat := Gps.GetLatitude
'        Debug.Dec(DestLat)
'        Debug.str(string(","))
'        debug.dec(lat)
'        pause(5000)
'        debug.cls
        CurrentDegreesGps := Compass.Degrees
        if CurrentDegreesGps > 180
'          debug.Dec(CurrentDegreesGps)
'          pause(5000)
'          debug.cls
          repeat until CurrentDegreesGps => 358 OR CurrentDegreesGps =< 2
            Move.TankRight(1)
            CurrentDegreesGps := Compass.Degrees
'            Longitude := Gps.GetLongitude
 '           debug.dec(Longitude)
'            debug.str(string("DL<LAR,"))
'            Debug.dec(CurrentDegreesGps)
'            pause(5000)
'            debug.cls
          if CurrentDegreesGps > 0 and CurrentDegreesGps < 180
'            debug.dec(CurrentDegreesGps)
'            pause(5000)
'            debug.cls
            repeat until CurrentDegreesGps => 358 OR CurrentDegreesGps =< 2
              Move.TankLeft(1)
              CurrentDegreesGps := Compass.Degrees
'              Longitude := Gps.GetLongitude
'              Debug.str(string("DL<LAL,"))
'              Debug.Dec(CurrentDegreesGps)
'              Pause(5000)
'              Debug.Cls

        if Ping.PingF
          ObstacleAvoid             
        Move.AllForward(20)
        Lat := Gps.GetLatitude
         
    if DestLat < Lat                'greater is east
      Lat := Gps.GetLatitude
'      LatHigh := Lat + 1
'      LatLow := Lat - 1
      repeat until DestLat == Lat '=< LatHigh and DestLat => LatLow - 1
        CurrentDegreesGps := Compass.Degrees
        Lat := Gps.GetLatitude
'        Debug.Dec(DestLat)
'        Debug.str(string(","))
'        debug.dec(lat)
        if CurrentDegreesGps > 180
          repeat until CurrentDegreesGps => 178 and CurrentDegreesGps =< 182
            Move.TankLeft(1)
            CurrentDegreesGps := Compass.Degrees
'            longitude := gps.GetLongitude
'            debug.dec(Longitude)
'            debug.str(string("DL>LAL,"))
'            debug.dec(CurrentDegreesGps)
'            pause(5000)
'            debug.cls
'            CurrentDegreesGps := compass.Degrees
        if CurrentDegreesGps > 0 and CurrentDegreesGps < 180
          repeat until CurrentDegreesGps => 178 and CurrentDegreesGps =< 182
            Move.TankRight(1)
            CurrentDegreesGps := Compass.Degrees
 '           Longitude := gps.GetLongitude
'            debug.Dec(Longitude)
'            debug.str(string("DL>LAR,"))
'            Debug.dec(CurrentDegreesGps)
'            pause(5000)
'            debug.cls
      if Ping.PingF
        ObstacleAvoid
      Move.AllForward(20)
      if Ping.PingF
        ObstacleAvoid
      Lat := Gps.GetLatitude         
                
repeat
  debug.str(string("we are here"))
  pause(1000)
  debug.cls


pub ObstacleAvoid
      CurrentDegreesGps := Compass.Degrees

      CurrentDestGpsHigh := CurrentDegreesGps + 94  '(90 + 4)

      if CurrentDestGpsHigh > 360                         'if you're trying to go to a nonexistent degree then...
        CurrentDestGpsHigh := CurrentDestGpsHigh - 360   'subtract 360 so your heading wraps around past 360

      CurrentDestGpsLow  := CurrentDegreesGps + 86 '(90-5)
                                                           'your current heading plus 88
      if CurrentDestGpsLow > 360                          'if you're trying to go to a nonexistent degree then...
        CurrentDestGpsLow := CurrentDestGpsLow - 360     'subtract 360 so your heading wraps around past 360

        
      Move.AllBackward(50)                                 'now move backwards

        
'      repeat until CurrentDegreesGps =< CurrentDestGpsHigh and CurrentDegreesGps => CurrentDestGpsLow 'turn until
                                                           'you've done a 90 degree turn 
        Move.TankRight(25) 'was 5                                 'turn right

        CurrentDegreesGps := compass.degrees              'what direction am I facing now?

      Move.AllForward(50)                                  'go forward
      
      CurrentDestGpsHigh := CurrentDegreesGps - 94  '90 + 4)                                  
 
      if CurrentDestGpsHigh < 0
        CurrentDestGpsHigh := CurrentDestGpsHigh + 360

      CurrentDestGpsLow := CurrentDegreesGps - 86  '(90-4)
      if CurrentDestGpsLow < 0
        CurrentDestGpsLow := CurrentDestGpsLow + 360
         
'      repeat until CurrentDegreesGps =< CurrentDestGpsLow and CurrentDegreesGps => CurrentDestGpsHigh 
    Move.TankLeft(25)

pri pause(ms)

    waitcnt(cnt + (ms * 80_000)) 'wait for (current clock count + (millisecond input * 80_000)     

  